整型
====
`Python` 语言是天然支持无限精度整型计算的，可以使用 `Python` 的整数计算能力来代替 `ext-bcmath`

构造
---
使用 `PyCore::int()` 函数来构造一个数字，可以传入整数、浮点数、字符串来初始化。

```php
$i1 = PyCore::int(12345678);
$i2 = PyCore::int('1234567890123456789012345678901234567890');
$i3 = PyCore::int(12345678.03);
```

运算
----
整数同样也是 `PyObject` 的实例，可以使用内置的方法类实现运算。

```php
$i = PyCore::int(12345435);
var_dump(strval($i->__pow__(3)));
var_dump(strval($i->__add__(4)));
```

将输出 `1881564851360655187875` ，由于超过了 `64位` 最大精度，因此输出结果将自动转为字符串类型。
